/*
 * coup.c
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

/* throw a coup */

coup ()
{
  register int i;
  register struct planet *l;

  if (me->p_kills < 1.0)
    {
#ifdef SHORT_PACKETS
      spwarning ("You must have one kill to throw a coup", 3);
#else
      warning ("You must have one kill to throw a coup");
#endif
      return;
    }
  if (!(me->p_flags & PFORBIT))
    {
#ifdef SHORT_PACKETS
      spwarning ("You must orbit your home planet to throw a coup", 4);
#else
      warning ("You must orbit your home planet to throw a coup");
#endif
      return;
    }
  for (i = 0, l = &planets[i]; i < MAXPLANETS; i++, l++)
    {
      if ((l->pl_owner == me->p_team) && (l->pl_armies > 0))
	{
#ifdef SHORT_PACKETS
	  spwarning ("You already own a planet!!!", 5);
#else
	  warning ("You already own a planet!!!");
#endif
	  return;
	}
    }
  l = &planets[me->p_planet];

  if ((!(l->pl_flags & PLHOME)) || ((l->pl_flags & ALLTEAM) != me->p_team))
    {
#ifdef SHORT_PACKETS
      spwarning ("You must orbit your home planet to throw a coup", 6);
#else
      warning ("You must orbit your home planet to throw a coup");
#endif
      return;
    }

  if (l->pl_armies > 4)
    {
#ifdef SHORT_PACKETS
      spwarning ("Too many armies on planet to throw a coup", 7);
#else
      warning ("Too many armies on planet to throw a coup");
#endif
      return;
    }

  if (l->pl_couptime > 0)
    {
#ifdef SHORT_PACKETS
      spwarning ("Planet not yet ready for a coup", 8);
#else
      warning ("Planet not yet ready for a coup");
#endif
      return;
    }

  if (l->pl_flags & PLCOUP)
    {				/* Avoid race conditions */
      return;
    }

  /* the cases are now met.  We can have a coup. */

  l->pl_flags |= PLCOUP;
}
