static char rcsid[] = "$Header: /users/crown/jmn/Private/trek/src/INL/ntserv/RCS/data.c,v 1.4 1993/04/05 12:34:08 jmn Rel $";

/* $Log: data.c,v $
 * Revision 1.4  1993/04/05  12:34:08  jmn
 * INL3.99pl0
 *
 * Revision 1.3  1993/03/26  09:06:06  jmn
 * Added hadley's ping patches and misc cleanups. Play tested- works.
 *
 * Revision 1.2  1993/03/18  22:18:56  jmn
 * otlenreq and gamelenreq added
 *
 * Revision 1.3  92/03/19  21:34:53  terence
 * Added UDP mods (version 0.2, 3/17/92)
 * 
 * Revision 1.2  92/03/11  15:38:12  terence
 * added UDP mods
 *  */

/*
 * data.c
 */
#include "copyright.h"

#include <sys/types.h>		/* needed to define fd_set for inputMask */

#include "defs.h"
#include "struct.h"
#include "data.h"

struct player *players;
struct player *me;
struct torp *torps;
struct plasmatorp *plasmatorps;
struct status *status;
struct ship *myship;
struct stats *mystats;
struct planet *planets;
struct phaser *phasers;
struct message *messages;
struct mctl *mctl;
struct team *teams;

int oldalert = PFGREEN;		/* Avoid changing more than we have to */
int remap[9] =
{0, 1, 2, -1, 3, -1, -1, -1, 4};
int messpend;
int lastcount;
int mdisplayed;
int redrawall;
int selfdest;
int udcounter;
int lastm;
int delay;			/* delay for decaring war */
int rdelay;			/* delay for refitting */
int mapmode = 1;
int namemode = 1;
int showStats;
int showShields;
int warncount = 0;
int warntimer = -1;
int infomapped = 0;
int mustexit = 0;
int messtime = MESSTIME;
int keeppeace = 0;
int showlocal = 2;
int showgalactic = 2;
char *shipnos = "0123456789abcdefghijklmnopqrstuvwxyz";
int sock = -1;
int xtrekPort = 27320;
int shipPick;
int teamPick;
int repCount = 0;
char namePick[16];
char passPick[16];
fd_set inputMask;
int nextSocket;
char *host;
int noressurect = 0;
int userVersion = 0, userUdpVersion = 0;
int timerDelay = 200000;	/* delay between sending stuff to client */

#ifdef RSA
char testdata[KEY_SIZE];
int RSA_Client;
char RSA_client_type[256];
#else
char testdata[16];
#endif

char *cl_version = (char *) 0;

int testtime = -1;
int tournplayers = 5;
int shipsallowed[NUM_TYPES];
int weaponsallowed[WP_MAX];
int plkills = 2;
int sbrank = 3;
int startplanets[MAXPLANETS];
int binconfirm = 1;
int chaos = 0;
int topgun = 0;			/* added 12/9/90 TC */
int newturn = 0;		/* added 1/20/91 TC */
int to_num, to_len;		/* time out stuff */
int hourratio = 1;		/* Fix thing to make guests advance fast */
int hiddenenemy = 1;
float maxload = 0.7;

int udpSock = (-1);		/* UDP - the almighty socket */
int commMode = 0;		/* UDP - initial mode is TCP only */
int udpAllowed = 1;		/* UDP - sysdefaults */

double oldmax = 0.0;

extern double Sin[], Cos[];	/* Initialized in sintab.c */

char teamlet[] =
{'I', 'F', 'R', 'X', 'K', 'X', 'X', 'X', 'O'};
char *teamshort[9] =
{"IND", "FED", "ROM", "X", "KLI", "X", "X", "X", "ORI"};
char pseudo[PSEUDOSIZE];
char login[PSEUDOSIZE];
char *shiptypes[] =
{"SC", "DD", "CA", "BB", "AS", "SB", "GA", "AT", "??"};

struct rank ranks[NUMRANKS] =
{
  {0.0, 0.0, 0.0, "Ensign"},
  {2.0, 1.0, 0.0, "Lieutenant"},

#ifdef nodef
   { 4.0, 2.0, 0.8, "Lt. Cmdr."}, 
   { 8.0, 3.0, 0.8, "Commander"},
   {15.0, 4.0, 0.8, "Captain"},
   {20.0, 5.0, 0.8, "Flt. Capt."},
   {25.0, 6.0, 0.8, "Commodore"},
   {30.0, 7.0, 0.8, "Rear Adm."},
   {40.0, 8.0, 0.8, "Admiral"},
#endif

  {4.0, 2.0, 0.0, "Lt. Cmdr."},
  {8.0, 3.0, 0.0, "Commander"},
  {15.0, 4.0, 0.0, "Captain"},
  {20.0, 5.0, 0.0, "Flt. Capt."},
  {25.0, 6.0, 0.0, "Commodore"},
  {30.0, 7.0, 0.0, "Rear Adm."},
  {40.0, 8.0, 0.0, "Admiral"},
};

int *INLteams;
int *INLteamschosen;
int *captains;
int *pausereq;
int *gamelenreq;
char (*teamname)[20];
int *otlenreq;
int *continuereq;
int *confinereq;
int *timeoutreq;
int *startreq;
char *regreq;
int *restartreq;
int *newgalaxyreq;
long *INL_timeleft;
int *INL_period;
int INL_game_length, INL_overtime_length;
int onHomeTeam;
struct Queue *wait_queue;
int *resetInProgress;
int *setarmyreq;
int *initial_armies;
int Observer = 0;

int gen_distress = 0;		/* generic distress support */
#ifdef SHORT_PACKETS
int send_short = 0;
#endif
/* Hope this cures it */

#ifdef PING
int ping = 0;			/* to ping or not to ping, client's decision */
long packets_sent = 0;		/* # all packets sent to client */
long packets_sent_skipped = 0;	/* # packets skipped because update too small */
long packets_received = 0;	/* # all packets received from client */
long packets_received_skipped = 0;	/* # packets skipped because update too small */
int ping_ghostbust = 0;		/* ghostbust timer */

/* defaults variables */
int activity_threshold = 0;	/* in bytes, how big should an update be before
				   we update our lag and loss stats?  This 
				   number is used as is for default protocol 
				   and halved for SHORT_PACKETS */

int ping_freq = 1;		/* ping freq. in seconds */
int ping_iloss_interval = 10;	/* in values of ping_freq */
int ping_allow_ghostbust = 0;	/* allow ghostbust detection from
				   ping_ghostbust (cheating possible) */
int ping_ghostbust_interval = 5;	/* in ping_freq, when to ghostbust
					   if allowed */
#endif

/* the following copied out of BRM data.c */

int num_distress;
/* the index into distmacro array should correspond with the correct dist_type */
struct dmacro_list distmacro[] = {
	{ 'X', "no zero", "this should never get looked at" },
	{ 't', "taking", " %T%c->%O (%S) Carrying %a to %l%?%n>-1%{ @ %n%}\0"},
	{ 'o', "ogg", " %T%c->%O Help Ogg %p at %l\0" },
	{ 'b', "bomb", " %T%c->%O %?%n>4%{bomb %l @ %n%!bomb%}\0"},
	{ 'c', "space_control", " %T%c->%O Help Control at %L\0" },
	{ '1', "save_planet", " %T%c->%O Help at %l! %?%a>0%{ (have %a arm%?%a=1%{y%!ies%}) %} %s%% shld, %d%% dam, %f%% fuel\0" },
	{ '2', "base_ogg", " %T%c->%O Sync with --]> %g <[-- OGG ogg OGG base!!\0" },
	{ '3', "help1", " %T%c->%O Help me! %d%% dam, %s%% shd, %f%% fuel %a armies.\0" },
	{ '4', "help2", " %T%c->%O Help me! %d%% dam, %s%% shd, %f%% fuel %a armies.\0" },
	{ 'e', "escorting", " %T%c->%O ESCORTING %g (%d%%D %s%%S %f%%F)\0" },
	{ 'p', "ogging", " %T%c->%O Ogging %h\0" },
	{ 'm', "bombing", " %T%c->%O Bombing %l @ %n\0" },
	{ 'l', "controlling", " %T%c->%O Controlling at %l\0" },
	{ '5', "asw", " %T%c->%O Anti-bombing %p near %b.\0" } ,
	{ '6', "asbomb", " %T%c->%O DON'T BOMB %l. Let me bomb it (%S)\0" } ,
	{ '7', "doing1", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal.  %d%% dam, %s%% shd, %f%% fuel\0" } ,
	{ '8', "doing2", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal.  %d%% dam, %s%% shd, %f%% fuel\0" } ,
	{ 'f', "free_beer", " %T%c->%O %p is free beer\0" },
	{ 'n', "no_gas", " %T%c->%O %p @ %l has no gas\0" },
	{ 'h', "crippled", " %T%c->%O %p @ %l crippled\0" },
	{ '9', "pickup", " %T%c->%O %p++ @ %l\0" },
	{ '0', "pop", " %T%c->%O %l%?%n>-1%{ @ %n%}!\0"},
	{ 'F', "carrying", " %T%c->%O %?%S=SB%{Your Starbase is c%!C%}arrying %?%a>0%{%a%!NO%} arm%?%a=1%{%y%!ies%}.\0" },
	{ '@', "other1", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal. (%d%%D, %s%%S, %f%%F)\0" },
	{ '#', "other2", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal. (%d%%D, %s%%S, %f%%F)\0" },
	{ 'E', "help", " %T%c->%O Help(%S)! %s%% shd, %d%% dmg, %f%% fuel,%?%S=SB%{ %w%% wtmp,%!%}%E%{ ETEMP!%}%W%{ WTEMP!%} %a armies!\0" },
	{ '\0', '\0', '\0'},
};

int	F_client_feature_packets = 0;
#ifdef SHORT_PACKETS
int 	F_why_dead = 0;
#endif
