
/*
 * enter.c
 * $Ident:$
 * 
 * $Log: enter.c,v $
 * Revision 1.9  1993/04/05  12:34:08  jmn
 * INL3.99pl0
 *
 * Revision 1.8  1993/03/18  00:17:06  jmn
 * Redid pck crediting by adding timekillgotten to player struct. This should
 * handle pck with no problems simply based on time you held your kill.
 * also added gametime and free slot commands to captain commands. fixed
 * sb problem with tticks where if you ONLY play sb in tmode you still have
 * 0 tticks and so you don't get no stats.
 *
 * Revision 1.7  1993/03/16  00:23:52  jmn
 * Changed way stats are done to use .players file as source for printing
 * out end game stats. Had to modify struct.h AGAIN to slightly alter
 * .players file format (so we know what team each guy last played on).
 * After game is played run pwstats (ver 1.1) on .players file to get stats.
 * Note that OLD format .players files will hose the pwstats program.
 *
 * Revision 1.6  1993/03/13  02:13:26  jmn
 * Added -DSTDBG flag to check whether this whole mess works. Alpha tested
 * and all seems ok. This is the version sent out to beta testers.
 *
 * Revision 1.5  1993/03/11  21:34:52  jmn
 * Did ikko-ikki's suggestion of tad=tac+cak - also did pck filtering for
 * mutuals based on time of last death for the killer < 0.5 sec.
 *
 * Revision 1.4  1993/03/11  12:11:29  jmn
 * untested acc kill crediting first draft
 *
 * Revision 1.3  1993/03/10  07:01:11  jmn
 * Ran clue game successfully- no major bugs except some problems with
 * kill counting in non-tmode- attempted to fix that and also made the
 * exit of a player only write to the gandhi_stats file if there is a
 * tournament. This may have problems when the conquer happens- dunno
 * yet.
 *
 * Revision 1.2  1993/03/09  00:10:19  jmn
 * First attempt at adding gandhi type stats- doesn't seem to work
 *
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#ifdef USE_MMAP
#include <sys/mman.h>
#include <sys/file.h>
#else
#ifndef MACH
#include <sys/ipc.h>
#include <sys/shm.h>
#endif
#endif
#include <errno.h>
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>		/* 7/16/91 TC */
#include "defs.h"
#include "struct.h"
#include "data.h"

/* Enter the game */

long rrandom ();

/* change 5/10/91 TC -- if tno == 4, independent */
				/* tno == 5 Terminator */
enter (tno, disp, pno, s_type)
     int tno;
     int disp;			/* not used, so I used it 7/27/91 TC */
     int pno;
     int s_type;
{
  static int lastteam = -1;
  static int lastrank = -1;
  char buf[80];
  char addrbuf[10];
  int startplanet;

  (void) strncpy (me->p_name, pseudo, sizeof (me->p_name));
  me->p_name[sizeof (me->p_name) - 1] = '\0';
  getship (myship, s_type);
  /* Need 2 kills to use plasma torpedoes */
  if ((s_type != STARBASE) && (s_type != ATT) && plkills > 0)
    {
      me->p_ship.s_plasmacost = -1;
    }
  me->p_updates = 0;
  me->p_flags = PFSHIELD;
  if (s_type == STARBASE)
    me->p_flags |= PFDOCKOK;
  me->p_dir = 0;
  me->p_desdir = 0;
  me->p_speed = 0;
  me->p_desspeed = 0;
  me->p_subspeed = 0;
  if ((tno == 4) || (tno == 5))
    {				/* change 5/10/91 TC new case, indep */
      me->p_team = 0;
      placeIndependent ();	/* place away from others 1/23/92 TC */
    }
  else
    {
      me->p_team = (1 << tno);
      for (;;)
	{
	  startplanet = tno * 10 + rrandom () % 10;
	  if (startplanets[startplanet])
	    break;
	}
      me->p_x = planets[startplanet].pl_x + (rrandom () % 10000) - 5000;
      me->p_y = planets[startplanet].pl_y + (rrandom () % 10000) - 5000;
      if (me->p_x < 0)
	me->p_x = 0;
      if (me->p_y < 0)
	me->p_y = 0;
      if (me->p_x > GWIDTH)
	me->p_x = GWIDTH;
      if (me->p_y > GWIDTH)
	me->p_y = GWIDTH;
    }
  me->p_ntorp = 0;
  me->p_cloakphase = 0;
  me->p_nplasmatorp = 0;
  me->p_damage = 0;
  me->p_subdamage = 0;
  me->p_etemp = 0;
  me->p_etime = 0;
  me->p_wtemp = 0;
  me->p_wtime = 0;
  me->p_shield = me->p_ship.s_maxshield;
  me->p_subshield = 0;
  me->p_swar = 0;
  me->p_kills = 0.0;
  me->p_armies = 0;
  me->p_docked = 0;
  me->mykills[0] = NULL;
  me->p_port[0] = VACANT;
  me->p_port[1] = VACANT;
  me->p_port[2] = VACANT;
  me->p_port[3] = VACANT;

  me->p_stats.last_team = teamlet[me->p_team];
  me->p_stats.last_num = shipnos[me->p_no];

/*    if (!keeppeace) me->p_hostile = (FED|ROM|KLI|ORI); */
  if (!keeppeace)
    auto_peace ();
  me->p_hostile &= ~me->p_team;

  /* join message stuff */

  sprintf (buf, "%c%c", teamlet[me->p_team], shipnos[me->p_no]);
  strncpy (me->p_mapchars, buf, 2);
  if (lastteam != tno || lastrank != mystats->st_rank)
    {
      char buf[80];

      lastteam = tno;
      lastrank = mystats->st_rank;
      sprintf (addrbuf, " %c%c->ALL",
	       teamlet[me->p_team], shipnos[me->p_no]);
      if ((tno == 4) && (strcmp (me->p_monitor, "Nowhere") == 0))
	{
	  /* change 5/10/91, 8/28/91 TC */
	  long curtime;
	  struct tm *tmstruct;
	  char buf2[40];
	  int queuesize;
	  int hour;

	  time (&curtime);
	  tmstruct = localtime (&curtime);
	  if (!(hour = tmstruct->tm_hour % 12))
	    hour = 12;
	  sprintf (buf, "It's %d:%02d%s, time to die.", hour, tmstruct->tm_min,
		   tmstruct->tm_hour >= 12 ? "pm" : "am");
	  if ((queuesize = status->count - status->wait) > 0)
	    {
	      sprintf (buf2, "  Approximate queue size: %d.", status->answer);
	      strcat (buf, buf2);
	    }
	  pmessage2 (buf, 0, MALL, addrbuf, me->p_no);
	}
      else if (tno == 5)
	{			/* change 7/27/91 TC */
	  char buf2[80];

	  if (players[disp].p_status != PFREE)
	    {
	      sprintf (buf2, "%c%c has been targeted for termination.",
		       teamlet[players[disp].p_team],
		       shipnos[players[disp].p_no]);
	      pmessage2 (buf2, 0, MALL, addrbuf, me->p_no);
	    }
	}
      sprintf (buf, "%s %.16s joining as %2.2s (%.16s@%.16s)",
	       ranks[me->p_stats.st_rank].name,
	       me->p_name,
	       me->p_mapchars,
	       me->p_login,
	       me->p_monitor);
      pmessage2 (buf, 0, MALL | MJOIN, addrbuf, me->p_no);
    }

  me->p_fuel = myship->s_maxfuel;
  delay = 0;
}

/* my idea of avoiding using the war window 8/16/91 TC */
auto_peace ()
{
  int i, num[MAXTEAM];
  struct player *p;

  num[0] = num[FED] = num[ROM] = num[KLI] = num[ORI] = 0;
  for (i = 0, p = players; i < MAXPLAYER; i++, p++)
    if (p->p_status != PFREE)
      num[p->p_team]++;
  if (status->tourn)
    me->p_hostile =
      ((FED * (num[FED] >= tournplayers)) |
       (ROM * (num[ROM] >= tournplayers)) |
       (KLI * (num[KLI] >= tournplayers)) |
       (ORI * (num[ORI] >= tournplayers)));
  else
    me->p_hostile = FED | ROM | KLI | ORI;
}

/* code to avoid placing bots on top of others 1/23/92 TC */

#define INDEP (GWIDTH/3)	/* width of region they can enter */

placeIndependent ()
{
  int i;
  struct player *p;
  int good, failures;

  failures = 0;
  while (failures < 5)
    {				/* don't try too hard to get them in */
      me->p_x = GWIDTH / 2 + (rrandom () % INDEP) - INDEP / 2;	/* middle 9th of */
      me->p_y = GWIDTH / 2 + (rrandom () % INDEP) - INDEP / 2;	/* galaxy */
      good = 1;
      for (i = 0, p = players; i < MAXPLAYER; i++, p++)
	if ((p->p_status != PFREE) && (p != me))
	  {
	    if ((ABS (p->p_x - me->p_x) < TRACTDIST) &&		/* arbitrary def */
		(ABS (p->p_y - me->p_y) < TRACTDIST))
	      {			/* of too close */
		failures++;
		good = 0;
		break;
	      }
	  }
      if (good)
	return;
    }
  fprintf (stderr, "Couldn't place the bot successfully.\n");
}

#if defined(USE_MMAP) && defined(USE_VALLOC)
#define memalign(align, len) valloc(len)
#endif

openmem ()
{
  extern int errno;
#ifndef USE_MMAP
#ifndef MACH
  int shmemKey = PKEY;
  int shmid;
#endif
#endif
  struct memory *sharedMemory;

  errno = 0;
#ifdef USE_MMAP
  {
    FILE *fp;
    int len, pagesize;
    extern int errno;
    if (access ("sharedMem", R_OK) < 0)
      {
	if (errno != ENOENT)
	  {
	    perror ("in openmem");
	    exit (1);
	  }
	startdaemon ();
	sleep (2);
	if (access ("sharedMem", R_OK) < 0)
	  {
	    fprintf (stderr, "Daemon not running! (err:%d)\n", errno);
	    exit (1);
	  }
      }
    fp = fopen ("sharedMem", "r+");
    if (fp == NULL)
      {
	perror ("can't open mmap file");
	exit (1);
      }
    len = sizeof (struct memory);
    pagesize = getpagesize ();
    if ((len % pagesize) != 0)
      len += pagesize - (len % pagesize);
    sharedMemory = (struct memory *) memalign (pagesize, len);
    if (sharedMemory == NULL)
      {
	perror ("memalign failed");
	exit (1);
      }
    errno = 0;
    mmap (sharedMemory, len, PROT_READ | PROT_WRITE, MAP_FIXED | MAP_SHARED,
	  fileno (fp), 0);
    if (errno != 0)
      {
	perror ("mmap failed");
	exit (1);
      }
    fclose (fp);
  }
#else
#ifndef MACH
  shmid = shmget (shmemKey, 0, 0);
  if (shmid < 0)
    {
      if (errno != ENOENT)
	{
	  perror ("shmget");
	  exit (1);
	}
      startdaemon ();
      sleep (2);
      shmid = shmget (shmemKey, 0, 0);
      if (shmid < 0)
	{
	  fprintf (stderr, "Daemon not running (err:%d)\n", errno);
	  exit (1);
	}
    }
  sharedMemory = (struct memory *) shmat (shmid, 0, 0);
#else
  {
#include <mach.h>
    extern port_t name_server_port;
    port_t netmemory_port;
    port_t obj;
    kern_return_t ret;

    ret = netname_look_up (name_server_port, "", "netmemoryserver",
			   &netmemory_port);
    if (ret != KERN_SUCCESS)
      {
	mach_error ("getting netmemoryserver port", ret);
	exit (1);
      }

    ret = netname_look_up (name_server_port, "", "netrek",
			   &obj);
    if (ret != KERN_SUCCESS)
      {
	startdaemon ();
	sleep (2);
	ret = netname_look_up (name_server_port, "", "netrek",
			       &obj);
	if (ret != KERN_SUCCESS)
	  {
	    mach_error ("getting netrek port", ret);
	    fprintf (stderr, "Daemon not running\n");
	    exit (1);
	  }
      }

    ret = vm_map (task_self (), &sharedMemory, sizeof (struct memory), 0, 1,
		  obj, 0, 0, VM_PROT_READ | VM_PROT_WRITE,
		  VM_PROT_READ | VM_PROT_WRITE, VM_INHERIT_SHARE);
    if (ret != KERN_SUCCESS)
      {
	mach_error ("vm_map", ret);
	exit (1);
      }
  }
#endif
#endif
  if (sharedMemory == (struct memory *) -1)
    {
      perror ("shared memory");
      exit (1);
    }
  players = sharedMemory->players;
  torps = sharedMemory->torps;
  plasmatorps = sharedMemory->plasmatorps;
  status = sharedMemory->status;
  planets = sharedMemory->planets;
  phasers = sharedMemory->phasers;
  mctl = sharedMemory->mctl;
  messages = sharedMemory->messages;
  teams = sharedMemory->teams;

  /* there has got to be a better way... */
  INLteams = sharedMemory->INLteams;
  INLteamschosen = sharedMemory->INLteamschosen;
  captains = sharedMemory->captains;
  pausereq = sharedMemory->pausereq;
  gamelenreq = sharedMemory->gamelenreq;
  otlenreq = sharedMemory->otlenreq;
  continuereq = sharedMemory->continuereq;
  confinereq = sharedMemory->confinereq;
  timeoutreq = sharedMemory->timeoutreq;
  startreq = sharedMemory->startreq;
  restartreq = sharedMemory->restartreq;
  newgalaxyreq = sharedMemory->newgalaxyreq;
  regreq = sharedMemory->regreq;
  INL_timeleft = &(sharedMemory->INL_timeleft);
  INL_period = &(sharedMemory->INL_period);
  resetInProgress = &(sharedMemory->resetInProgress);
  wait_queue = sharedMemory->Wait_Queue;
  teamname = sharedMemory->teamname;
  setarmyreq = sharedMemory->setarmyreq;
  initial_armies = &(sharedMemory->initial_armies);
}
