static char rcsid[] = "$Header: /users/crown/jmn/Private/trek/src/INL/ntserv/RCS/getentry.c,v 1.4 1993/04/05 12:34:08 jmn Rel $";

/* $Log: getentry.c,v $
 * Revision 1.4  1993/04/05  12:34:08  jmn
 * INL3.99pl0
 *
 * Revision 1.3  1993/04/05  03:08:27  jmn
 * ran game april 4 - bug found - cannot orbit orion - if you do get teleported
 * to rom
 *
 * Revision 1.2  1993/04/02  23:45:18  jmn
 * pl12
 *
 * Revision 1.1  1993/04/02  20:07:23  jmn
 * Initial revision
 *
 * Revision 1.3  92/03/19  21:34:43  terence
 * Added UDP mods (version 0.2, 3/17/92)
 * 
 * Revision 1.2  92/03/11  15:51:55  terence
 * added UDP mods
 *  */

/*
 * getentry.c
 *
 * Kevin P. Smith  1/31/89
 *
 * Get an outfit and team entry request from user.
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#ifndef SOLARIS2
#include <strings.h>
#endif
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

extern int overload;		/* 7/31/91 TC let overloaded join any team */

getEntry (team, stype)
     int *team;
     int *stype;
{
  int i;
  extern char start_pseudo[], start_login[];	/* change 1/28/91 TC */

  int switching = -1;		/* confirm switches 7/27/91 TC */

  if (mustexit)
    exitGame ();

  FD_SET (CP_OUTFIT, &inputMask);
  for (;;)
    {
      /* updateShips so he knows how many players on each team */
      updateShips ();
      sendMaskPacket (tournamentMask (me->p_team));
      flushSockBuf ();
      /* Have we been busted? */
      if (me->p_status == PFREE)
	{
	  me->p_status = PDEAD;
	  me->p_explode = 600;
	}
      socketPause ();
      readFromClient ();
      if (isClientDead ())
	{
	  int i;

	  if (noressurect)
	    exitGame ();
	  printf ("Ack!  The client went away!\n");
	  printf ("I will attempt to resurrect him!\n");

	  /* UDP fail-safe */
	  commMode = COMM_TCP;
	  if (udpSock >= 0)
	    closeUdpConn ();

	  /* For next two minutes, we try to restore connection */
	  shutdown (sock, 2);
	  sock = -1;
	  for (i = 0;; i++)
	    {
	      switch (me->p_status)
		{
		case PFREE:
		  me->p_status = PDEAD;
		  me->p_explode = 600;
		  break;
		case PALIVE:
		  me->p_ghostbuster = 0;
		  break;
		case POBSERV:
		  me->p_status = PDEAD;
		case PDEAD:
		  me->p_explode = 600;
		  break;
		default:
		  me->p_explode = 600;
		  me->p_ghostbuster = 0;
		  break;
		}
	      my_sleep (5);
	      if (connectToClient (host, nextSocket))
		break;
	      if (i == 6)
		{		/* was 23.. shortened for INL */
		  printf ("Oh well, maybe I'm getting rusty!\n");
		  switch (me->p_status)
		    {
		    case PFREE:
		      break;
		    case PALIVE:
		      me->p_ghostbuster = 1000000;
		      break;
		    case POBSERV:
		      me->p_status = PDEAD;
		    case PDEAD:
		      me->p_explode = 0;
		      break;
		    default:
		      me->p_explode = 0;
		      me->p_ghostbuster = 1000000;
		      break;
		    }
		  exitGame ();
		}
	    }
	  printf ("A miracle!  He's alive!\n");
	  teamPick = -1;
	  updateSelf ();
	  updateShips ();
	  flushSockBuf ();
	}
      if (teamPick != -1)
	{
	  if (teamPick < 0 || teamPick > 3)
	    {
	      warning ("Get real!");
	      sendPickokPacket (0);
	      teamPick = -1;
	      continue;
	    }
	  if (!(tournamentMask (me->p_team) & (1 << teamPick)))
	    {
#ifdef SHORT_PACKETS
	      spwarning ("I cannot allow that.  Pick another team", 9);
#else
	      warning ("I cannot allow that.  Pick another team");
#endif
	      sendPickokPacket (0);
	      teamPick = -1;
	      continue;
	    }

	  if (((1 << teamPick) != me->p_team) &&
	      (me->p_team != ALLTEAM))	/* switching teams 7/27/91 TC */
	    if ((switching != teamPick) && (me->p_whydead != KGENOCIDE))
	      {
		switching = teamPick;
#ifdef SHORT_PACKETS
		spwarning ("Please confirm change of teams.  Select the new team again.", 10);
#else
		warning ("Please confirm change of teams.  Select the new team again.");
#endif
		sendPickokPacket (0);
		teamPick = -1;
		continue;
	      }
	  /* His team choice is ok. */
	  if (shipPick < 0 || shipPick >= ATT)
	    {
#ifdef SHORT_PACKETS
	      spwarning ("That is an illegal ship type.  Try again.", 11);
#else
	      warning ("That is an illegal ship type.  Try again.");
#endif
	      sendPickokPacket (0);
	      teamPick = -1;
	      continue;
	    }
	  if (shipsallowed[shipPick] == 0)
	    {
	      warning ("That ship hasn't been designed yet.  Try again.");
	      sendPickokPacket (0);
	      teamPick = -1;
	      continue;
	    }
	  /* basically make it a free for all before tmode starts */
	  /* keep the natives happy while they wait */
	  if (shipPick == STARBASE && status->tourn)
	    {
	      if (teams[1 << teamPick].s_turns > 0 && !chaos && !topgun)
		{
		  char buf[100];
		  sprintf (buf, "Not constructed yet. %d minutes required for completion",
			   teams[me->p_team].s_turns);
		  warning (buf);
		  sendPickokPacket (0);
		  teamPick = -1;
		  continue;
		}
	      if (mystats->st_rank < sbrank)
		{
		  char buf[100];

		  sprintf (buf, "You need a rank of %s or higher to command a starbase!", ranks[sbrank].name);
		  warning (buf);
		  sendPickokPacket (0);
		  teamPick = -1;
		  continue;
		}
	      if (numPlanets (1 << teamPick) < 5 && !chaos && !topgun)
		{
		  warning ("Your team's stuggling economy cannot support such an expenditure!");
		  sendPickokPacket (0);
		  teamPick = -1;
		  continue;
		}
	      for (i = 0; i < MAXPLAYER; i++)
		{
		  if (i != me->p_no &&
		      players[i].p_status == PALIVE &&
		      players[i].p_team == (1 << teamPick) &&
		      players[i].p_ship.s_type == STARBASE && !chaos)
		    {
		      warning ("Your side already has a starbase!");
		      sendPickokPacket (0);
		      teamPick = -1;
		      break;
		    }
		}
	    }
	  if (teamPick == -1)
	    continue;
	  break;
	}
    }
  if (me->p_team != (1 << teamPick))
    {
      me->p_hostile |= ALLTEAM;
    }
  *team = teamPick;
  *stype = shipPick;
  sendPickokPacket (1);
  handleUpdatesReq (NULL);	/* 12/21/92 - Brian Paulsen */
  flushSockBuf ();
}

tournamentMask (team)
     int team;
{
  int i;

  if (!time_access ())		/* support time_access file */
    return (0);
  if (mustexit)
    return (0);
  if (*resetInProgress)
    return (0);

  if (onHomeTeam)
    {
      return (INLteams[0]);
    }
  else
    {
      return (INLteams[1]);
    }
}

realNumShips (owner)
     int owner;
{
  int i, num = 0;
  struct player *p;

  for (i = 0, p = players; i < MAXPLAYER; i++, p++)
    {
      if (p->p_status != PFREE && p->p_status != POBSERV &&
	  p->p_team == owner)
	{
	  num++;
	}
    }
  return (num);
}

deadTeam (owner)
     int owner;
{
  int i, num = 0;
  struct planet *p;

  if (!time_access ())		/* server off */
    return (1);
  if (planets[remap[owner] * 10 - 10].pl_couptime == 0)
    return (0);
  for (i = 0, p = planets; i < MAXPLANETS; i++, p++)
    {
      if (p->pl_owner & owner)
	{
	  num++;
	}
    }
  if (num != 0)
    return (0);
  return (1);
}
