
/*
 * main.c
 */
#include "copyright.h"

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>
#include <setjmp.h>
#include <pwd.h>
#include <time.h>
#include <sys/wait.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
/* #include "templates.h" */
#include "packets.h"
#include "../version.h"
#include "../patchlevel.h"
#include "../cflags.h"

jmp_buf env;
int startTkills, startTlosses, startTarms, startTplanets, startTticks;
char start_login[16];		/* change 1/25/91 TC */
char start_name[16];		/* change 1/25/91 TC */
int goAway = 0;			/* change 4/14/91 TC */
int ignored[MAXPLAYER];		/* change 7/24/91 TC */

int overload = 0;		/* global 7/31/91 TC */
/* overload indicates a request for a reserved slot */

int indie = 0;			/* always be indie 8/28/91 TC */

main (argc, argv)
     int argc;
     char **argv;
{
  int intrupt ();
  int team, s_type;
  int pno;
  int usage = 0;
  int err = 0;
#ifdef SOLARIS2
  char *cp, *name, *ptr;
#else
  char *cp, *name, *ptr, *rindex ();
#endif
  char buf[80];
  struct passwd *pwent, *getpwuid ();
  int reaper ();
  int callHost = 0;
  long starttime;
  int i;
#ifdef DS
  extern int forceShutdown ();
#endif

  onHomeTeam = !strcmp (argv[0], "home");	/* argv[0] set by ntstart */

  name = *argv++;
  argc--;
  if ((ptr = rindex (name, '/')) != NULL)
    name = ptr + 1;
  while (*argv)
    {
      if (**argv == '-')
	++ * argv;
      else
	break;

      argc--;
      ptr = *argv++;
      while (*ptr)
	{
	  switch (*ptr)
	    {
	    case 'u':
	      usage++;
	      break;
	    case 'i':
	      indie++;
	      break;		/* 8/28/91 TC */
	    case 'R':
	      if (getuid () == geteuid ())
		overload++;
	      break;
	    case 's':
	      xtrekPort = atoi (*argv);
	      callHost = 1;
	      argv++;
	      argc--;
	      break;
	    case 'd':
	      host = *argv;
	      argc--;
	      argv++;
	      break;
	    case 'O':
	      Observer = 1;
	      break;
	    case 'H':
	      onHomeTeam = 1;
	      break;
	    case 'A':
	      onHomeTeam = 0;
	      break;
	    default:
	      fprintf (stderr, "%s: unknown option '%c'\n", name, *ptr);
	      err++;
	      break;
	    }
	  ptr++;
	}
    }
  if (usage || err)
    {
      printUsage (name);
      exit (err);
    }
  /* compatability */
  if (argc > 0)
    host = argv[0];

  if (getenv ("NETREKDIR"))
    {
      if (chdir (getenv ("NETREKDIR")) != 0)
	fprintf (stderr, "couldn't chdir to $NETREKDIR:%s", getenv ("NETREKDIR"));
      if (chdir (NETREKDIR) != 0)
	{
	  perror ("chdir error");
	  fprintf (stderr, "couldn't chdir to NETREKDIR:%s", NETREKDIR);
	}
    }
  /* DEBUG {char dirbuf[1024]; printf("netrek cwd is %s\n", getwd(dirbuf));} */

  srrandom (getpid () * time ((long *) 0));
  readsysdefaults ();
  readFeatures();	/* new - TSH */
  /* this finds the shared memory information */
  openmem ();
  /*  fprintf(stderr,"mem opened\n"); /* DEBUG */
  me = NULL;			/* UDP fix (?) */
  if (callHost)
    {
      if (!connectToClient (host, xtrekPort))
	{
	  /* DEBUG */ fprintf (stderr, "connect to client failed\n");
	  exit (0);
	}
    }
  else
    {
      sock = 0;			/* Because we were forked by inetd! */
      checkSocket ();
      initClientData ();	/* "normally" called by connectToClient() */
    }
  /* fprintf(stderr,"connection opened\n");/* DEBUG */
  starttime = time (NULL);
  while (userVersion == 0)
    {
      /* Waiting for user to send his version number.
         * We give him ten seconds to do so...
       */
      if (starttime + 10 < time (NULL))
	{
	  exit (1);
	}
      socketPause ();
      readFromClient ();
    }
  if (!checkVersion ())
    exit (1);

#ifdef DS
  signal (SIGALRM, SIG_IGN);
  signal (SIGTERM, forceShutdown);
#endif

  sendMotd ();
  if (Observer)
    {
      pno = findtestslot ();
      if (pno < 0)
	{
	  /* trigger client's "Sorry, but you cannot play xtrek now.
	     Try again later." */
	  struct badversion_spacket packet;
	  packet.type = SP_BADVERSION;
	  packet.why = 1;
	  sendClientPacket (&packet);
	  flushSockBuf ();
	  exit (1);
	}
    }
  else
    {
      pno = findslot (overload, onHomeTeam ? 0 : 1);
      if (pno < 0)
	{
	  /* print some appropriate message */
	  exit (1);
	}
    }
#ifdef SLOT_PID
  make_slotpid_file (pno);
#endif
  me = &players[pno];
  me->p_no = pno;
#if defined(DS) && !defined(__CENTERLINE__)
  me->p_process = getpid ();
  me->p_timerdelay = timerDelay / 10000;
#endif

#ifdef __CENTERLINE__
   timerDelay = 1000000;
#endif

  myship = &me->p_ship;
  mystats = &me->p_stats;
  lastm = mctl->mc_current;
  SIGNAL (SIGINT, SIG_IGN);
  (void) SIGNAL (SIGCHLD, reaper);

  /* We set these so we won't bother updating him on the location of the
     *  other players in the galaxy which he is not near.  There is no
     *  real harm to doing this, except that he would then get more information
     *  than he deserves.
     * It is kind of a hack, but should be harmless.
   */
  me->p_x = -100000;
  me->p_y = -100000;
  me->p_team = 0;
  updateSelf ();		/* so he gets info on who he is */
  updateShips ();
  updatePlanets ();
  flushSockBuf ();

  /* Get login name */

  if ((pwent = getpwuid (getuid ())) != NULL)
    (void) strncpy (login, pwent->pw_name, sizeof (login));
  else
    (void) strncpy (login, "Bozo", sizeof (login));
  login[sizeof (login) - 1] = '\0';

  strcpy (pseudo, "Guest");

  strcpy (me->p_name, pseudo);
  me->p_team = INLteams[onHomeTeam ? 0 : 1];
  getname ();
  strcpy (pseudo, me->p_name);
  strcpy (start_name, me->p_name);	/* change 1/25/91 TC */

  keeppeace = (me->p_stats.st_flags / ST_KEEPPEACE) & 1;
/*    showgalactic = 1 + (me->p_stats.st_flags / ST_GALFREQUENT) & 1; */

  /* Set p_hostile to hostile, so if keeppeace is on, the guy starts off
     hating everyone (like a good fighter should) */
  me->p_hostile = (FED | ROM | KLI | ORI);

  s_type = CRUISER;
  me->p_planets = 0;
  me->p_genoplanets = 0;
  me->p_armsbomb = 0;
  me->p_genoarmsbomb = 0;
  /* Set up a reasonable default */
  me->p_whydead = KQUIT;

  (void) strncpy (me->p_login, login, sizeof (me->p_login));
  me->p_login[sizeof (me->p_login) - 1] = '\0';
  strcpy (start_login, login);	/* change 1/25/91 TC */
  {
    int i;
    for (i = 0; i < MAXPLAYER; i++)
      ignored[i] = 0;
  }

  (void) strncpy (me->p_monitor, host, sizeof (me->p_monitor));
  me->p_monitor[sizeof (me->p_monitor) - 1] = '\0';
  logEntry ();			/* moved down to get login/monitor 2/12/92 TMC */

#ifdef PING			/* 0 might just be legit for a local player */
  mystats->st_avrt = -1;
  mystats->st_stdv = -1;
  mystats->st_pkls_sc = -1;
  mystats->st_pkls_cs = -1;
#endif

  setjmp (env);			/* Reentry point of game */

  /* zeroing this after each death should be often enough,
     ** and very inexpensive.  Thus out of tmode, stats are counted
     ** only since last death... maybe a "feachure". - jn
   */
  if (!status->tourn)
    {
      startTkills = me->p_stats.st_tkills;
      startTlosses = me->p_stats.st_tlosses;
      startTarms = me->p_stats.st_tarmsbomb;
      startTplanets = me->p_stats.st_tplanets;
      startTticks = me->p_stats.st_tticks;
    }

  /* give the player the motd and find out which team he wants */
  if (me->p_status != PALIVE)
    {
      me->p_x = -100000;
      me->p_y = -100000;
      updateSelf ();
      updateShips ();
      teamPick = -1;
      flushSockBuf ();
      getEntry (&team, &s_type);
      repCount = 0;		/* Make sure he gets an update immediately */
    }
  if (goAway)
    {				/* change 4/14/91 TC */
      printStats ();
      exit (0);
    }
  if (team == -1)
    {
      exitGame ();
    }
  if (indie)
    team = 4;			/* force to independent 8/28/91 TC */
  redrawall = 1;

  for (i = 0; i <= MAX_CP_PACKETS; i++)
    FD_SET (i, &inputMask);	/* Allow all input now */

  enter (team, 0, me->p_no, s_type);
  /*
     for (i = 0; i < NSIG; i++) {
     SIGNAL(i, SIG_IGN);
     }
   */

  if (Observer)
    me->p_status = POBSERV;	/* put observer in game */
  else
    me->p_status = PALIVE;	/* Put player in game */

  me->p_ghostbuster = 0;

  /* Get input until the player quits or dies */
  input ();
}

exitGame ()
{
  char buf[80];
  char addrbuf[20];

  sendMaskPacket (0);

  if (captains[onHomeTeam ? 0 : 1] == me->p_no)
    free_captain ();

  if (me != NULL && me->p_team != ALLTEAM)
    {
      sprintf (buf, "%s %s (%s) leaving the game (%.16s@%.16s)",
	       ranks[me->p_stats.st_rank].name,
	       me->p_name,
	       me->p_mapchars,
	       me->p_login,
	       me->p_monitor);
      sprintf (addrbuf, " %c%c->ALL",
	       teamlet[me->p_team], shipnos[me->p_no]);
      pmessage2 (buf, 0, MALL | MLEAVE, addrbuf, me->p_no);
      me->p_stats.st_flags &= ~ST_CYBORG;	/* clear this flag 8/27/91 TC */
      savestats ();
      printStats ();
    }
  me->p_status = PFREE;
  me->p_ghostbuster = 0;
#if defined(PING) && defined(SHORT_PACKETS)
  if (packets_sent + packets_sent_skipped &&
      packets_received + packets_received_skipped)
    {
      printf ("%s: threshold: %d, %d%% packets over threshold (%d%% in)\n",
	      send_short ? "short-packets udp" : "regular udp",
	      activity_threshold,
	      (100 * packets_sent) / (packets_sent + packets_sent_skipped),
	      (100 * packets_received) /
	      (packets_received + packets_received_skipped));
    }
#endif
  exit (0);
}


printUsage (prog)
     char *prog;
{
  printf ("Usage: %s [-u] -s socket# machine\n",
	  prog);
}

sendMotd ()
{
  FILE *motd, *sysdef;
  char buf[100];		/* big enough... */
  int length;

  long curtime;
  struct tm *tmstruct;
  int hour;

  sprintf (buf, "Welcome to %s, patchlevel %d", version, PATCHLEVEL);
  sendMotdLine (buf);
  sendMotdLine ("Compiler option flags used for this server:");
  sendMotdLine (cflags);
  sendMotdLine (" ");
  sendMotdLine (" ");
  time (&curtime);
  tmstruct = localtime (&curtime);
  if (!(hour = tmstruct->tm_hour % 12))
    hour = 12;
  sprintf (buf, "Connection to server established at %d:%02d%s.", hour,
	   tmstruct->tm_min,
	   tmstruct->tm_hour >= 12 ? "pm" : "am");
  sendMotdLine (buf);
  sendMotdLine (" ");
  if (!time_access ())
    {
      sprintf (buf, "WE'RE CLOSED. SEE HOURS BELOW.");
      sendMotdLine (buf);
      sendMotdLine (" ");
    }

  /* the following will read a motd */
  if ((motd = fopen (MOTD, "r")) != NULL)
    {
      while (fgets (buf, sizeof (buf), motd) != NULL)
	{
	  buf[strlen (buf) - 1] = '\0';
	  sendMotdLine (buf);
	}
      (void) fclose (motd);
    }

  /* now we append the .sysdef */
  sendMotdLine (" ");
  sendMotdLine ("SYSDEF file contents:");
  sendMotdLine (" ");
  if ((sysdef = fopen (SYSDEF_FILE, "r")) != NULL)
    {
      while ((fgets (buf, sizeof (buf), sysdef) != NULL))
	{
	  buf[strlen (buf) - 1] = '\0';
	  sendMotdLine (buf);
	}
      (void) fclose (sysdef);
    }
}

reaper (sig)
{
#ifdef SOLARIS2
  while (waitpid ((pid_t) 0, (int *) 0, WNOHANG) > 0);
#else
  while (wait3 ((union wait *) 0, WNOHANG, (struct rusage *) 0) > 0)
/*    while (wait2((int *) 0, WNOHANG) > 0) */
    ;
#endif
}


/*
   reaper(sig)
   {
   while (wait3((union wait *) 0, WNOHANG, (struct rusage *) 0) > 0)
   ;
   }
 */

printStats ()
{
  int i;
  FILE *logfile;
  int curtime;

  logfile = fopen (LOGFILENAME, "a");
  if (!logfile)
    return;
  curtime = time (NULL);
  fprintf (logfile, "Leaving: %-16s (%c%c) %3dP %3dA %3dW/%3dL %3dmin %2d <%s@%s> %s",
	   me->p_name,
	   teamlet[me->p_team],
	   shipnos[me->p_no],
	   me->p_stats.st_tplanets - startTplanets,
	   me->p_stats.st_tarmsbomb - startTarms,
	   me->p_stats.st_tkills - startTkills,
	   me->p_stats.st_tlosses - startTlosses,
	   (me->p_stats.st_tticks - startTticks) / 600,
	   numPlanets (me->p_team),
	   me->p_login,
	   me->p_monitor,
	   ctime (&curtime));
#ifdef BD
   {
      int       count,val, min;

      min = (me->p_stats.st_tticks - startTticks) / 600;
      val = bd_borg(&count);
      if(min > 15 && (double)count/(double)min > 0.33){
         fprintf(logfile, "BD %s@%s ** %d (%d) ** in %dmin (\"%s\")\n",
            me->p_login, me->p_monitor, val, count, min,
            RSA_client_type);
      }
   }
#endif
  if (goAway)
    fprintf (logfile, "^^^ 2 players/1 slot.  was %s (%s)\n",
	     start_name, start_login);
  fclose (logfile);
}

#ifdef SLOT_PID

#define SLOT_PID_DIR	"slots"	/* probably to defs.h */
make_slotpid_file (pno)

     int pno;
{
  FILE *fo;
  char buf[80];

  (void) mkdir (SLOT_PID_DIR, 0700);	/* xx -- ignoring errors */

  sprintf (buf, "%s/%c", SLOT_PID_DIR, shipnos[pno]);
  if (!(fo = fopen (buf, "w")))
    {
      perror (buf);
      return;
    }
  fprintf (fo, "%d\n", getpid ());
  fclose (fo);
}
#endif

findtestslot ()
{
  register int i;

  for (i = MAXPLAYER - TESTERS; i < MAXPLAYER; i++)
    {
      if (players[i].p_status == PFREE)
	{			/* We have a free slot */
	  players[i].p_status = POUTFIT;	/* possible race condition */
	  break;
	}
    }
  if (i == MAXPLAYER)
    {
      return -1;		/* no room in tester slots */
    }
  bzero (&players[i].p_stats, sizeof (struct stats));
  players[i].p_stats.st_tticks = 1;
  return (i);
}
