
/*
 * redraw.c
 */
#include "copyright.h"

#include <stdio.h>
#include <signal.h>
#include <setjmp.h>		/* change 4/14/91 TC */
#include <math.h>
#include <sys/types.h>		/* needed for fd_set in inputMask */
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

static short nplayers;
extern char start_login[], start_name[];	/* change 4/14/91 TC */
extern int goAway;		/* change 4/14/91 TC */
extern jmp_buf env;		/* change 4/14/91 TC */

intrupt ()
{
/*    if (!binconfirm) testtime=0; */
  if (testtime == -1)
    {
      struct reserved_spacket sp;

      /* Give reasonable period of time to respond to query 
         *  (and test code if they need to) 
       */
      testtime = 200;
      makeReservedPacket (&sp);
      bcopy (sp.data, testdata, RESERVED_SIZE);
      sendClientPacket (&sp);
    }
  else if (testtime != 0)
    {
      testtime--;
      if (testtime == 0)
	{
	  /* User failed to respond to verification query.  Bye! */
	  if (!binconfirm)
	    me->p_stats.st_flags |= ST_CYBORG;	/* mark for reference 7/27/91 TC */
	  else
	    {
	      me->p_explode = 10;
	      me->p_whydead = KBINARY;
	      me->p_status = PEXPLODE;
	      fprintf (stderr, "User binary failed to verify\n");
#ifdef RSA
	      if (RSA_Client == 1)
		warning ("No customized binaries. Please use a blessed one.");
	      else if (RSA_Client == 2)
		warning ("Wrong RSA Client Version Number!");
	      else
		warning ("You need a spiffy new RSA client for this server!");
#else
	      warning ("No customized binaries.  Please use a blessed one.");
#endif
	    }
	}
    }
  if (me->p_status == PFREE)
    {
      me->p_ghostbuster = 0;
      me->p_status = PDEAD;
    }

/* Change 4/14/91 TC: fixing 2 players/1 slot bug here, since this is */
/* where the ghostbust check is */

  /* if ((strcmp(me->p_login, start_login) != 0) ||
     (strcmp(me->p_name, start_name) != 0)) {
     struct pstatus_spacket pstatus;
     goAway = 1;               /* get rid of this client! 
     warning("Sorry, your slot has been taken by another player.");
     pstatus.type=SP_PSTATUS;
     pstatus.pnum=0;
     pstatus.status = PDEAD;
     sendClientPacket(&pstatus);
     longjmp(env,0);
     } */


  if (!Observer || me->p_status == PEXPLODE)
    {
      if (me->p_status == PEXPLODE || me->p_status == PDEAD)
	{
	  FD_ZERO (&inputMask);
	}
      if (((me->p_status == PDEAD) || (me->p_status == POUTFIT))
	  && (me->p_ntorp <= 0) && (me->p_nplasmatorp <= 0))
	{
	  death ();
	}

      /* you quit during pause, you're outta there! -- no delay */
      if ((me->p_status == PEXPLODE || me->p_status == PDEAD) &&
	  status->gamepaused)
	death ();
    }

  auto_features ();
  updateClient ();
}

/* These are routines that need to be done on interrupts but
   don't belong in the redraw routine and particularly don't
   belong in the daemon. */

auto_features ()
{
  char buf[180];
  struct player *pl;
  struct planet *pln;
  unsigned char course;
  int troop_capacity = 0;

  if (Observer)
    {
      /* observer is usually status POBSERV which is sort of like PDEAD */
      /* may get set to PDEAD or PEXPLODE by daemon events. deal with
         ** those cases  reasonably gracefully */
      if (me->p_status != POBSERV)
	{
	  if (me->p_status == PDEAD || me->p_status == PEXPLODE)
	    {
	      death ();
	    }
	  else
	    me->p_status = POBSERV;
	}
      if (FD_ISSET (CP_SPEED, &inputMask))
	{
	  /* only let observer do a limited set of actions. */
	  FD_ZERO (&inputMask);
	  FD_SET (CP_MESSAGE, &inputMask);
	  FD_SET (CP_QUIT, &inputMask);
	  FD_SET (CP_LOGIN, &inputMask);
	  FD_SET (CP_OUTFIT, &inputMask);
	  FD_SET (CP_PLANLOCK, &inputMask);
	  FD_SET (CP_PLAYLOCK, &inputMask);
	  FD_SET (CP_SOCKET, &inputMask);
	  FD_SET (CP_OPTIONS, &inputMask);
	  FD_SET (CP_BYE, &inputMask);
	  FD_SET (CP_UPDATES, &inputMask);
	  FD_SET (CP_RESERVED, &inputMask);
	  FD_SET (CP_UDP_REQ, &inputMask);
	  FD_SET (CP_SEQUENCE, &inputMask);
#ifdef RSA
	  FD_SET (CP_RSA_KEY, &inputMask);
#endif
#ifdef PING
	  FD_SET (CP_PING_RESPONSE, &inputMask);
#endif
#ifdef SHORT_PACKETS
	  FD_SET (CP_S_REQ, &inputMask);
	  FD_SET (CP_S_THRS, &inputMask);
	  FD_SET (CP_S_MESSAGE, &inputMask);
	  FD_SET (CP_S_RESERVED, &inputMask);
#endif
	  FD_SET (MAX_CP_PACKETS, &inputMask);
	}

      /* handle quitting  -- it just happens for the observer */
      if (me->p_flags & PFSELFDEST)
	{
	  me->p_status = POUTFIT;
	  me->p_whydead = KQUIT;
	  death ();
	}

      if (me->p_flags & PFPLOCK)
	{
	  /* locked onto a player */
	  if (me->p_playerl < 0)
	    me->p_playerl = 0;

	  pl = &players[me->p_playerl];
	  if (pl->p_status != PALIVE)
	    {
	      /* me->p_playerl = -1; */
	      me->p_x = -100000;
	      me->p_y = -100000;
	      /* me->p_flags &= ~(PFPLOCK); */
#ifdef SHORT_PACKETS
	      spwarning ("Player lock lost while player dead.", 99);
#else
	      warning ("Player lock lost while player dead.");
#endif
	    }
	  else if (pl->p_team != me->p_team)
	    {
#ifdef SHORT_PACKETS
	      spwarning ("Can only lock on own team.", 100);
#else
	      warning ("Can only lock on own team.");
#endif
	      me->p_x = -100000;
	      me->p_y = -100000;
	      me->p_playerl = -1;	/* this is sort of gross and probably 
					   should be done more cleverly but oh well.. jmn */
	    }
	  else
	    {
	      /* follow a particular player */
	      me->p_ship.s_type = pl->p_ship.s_type;
	      me->p_x = pl->p_x;
	      me->p_y = pl->p_y;
	      me->p_shield = pl->p_shield;
	      me->p_damage = pl->p_damage;
	      me->p_armies = pl->p_armies;
	      me->p_fuel = pl->p_fuel;
	      me->p_wtemp = pl->p_wtemp;
	      me->p_etemp = pl->p_etemp;
	      me->p_flags = (pl->p_flags & ~(PFSELFDEST | PFPLOCK | PFPLLOCK)) |
		(me->p_flags & (PFSELFDEST | PFPLOCK | PFPLLOCK));
	      /* always cloaked, state of person watched will be obvious */
	      /* me->p_flags |= PFCLOAK; */
	      me->p_dir = pl->p_dir;
	      me->p_flags |= PFOBSERV;	/* future clients might understand this */
	      me->p_tractor = pl->p_tractor;

	      me->p_speed = pl->p_speed;
	      /* me->p_kills = pl->p_kills;  Very bad: will confuse enemies */
	    }
	}
      else if (me->p_flags & PFPLLOCK)
	{
	  /* locked onto a planet! */
	  if (me->p_planet >= 0 && me->p_planet < MAXPLANETS)
	    {
	      pln = &planets[me->p_planet];
	      if (pln->pl_owner != me->p_team)
		{
		  me->p_planet = -1;
		  me->p_flags &= ~(PFPLLOCK);
		  me->p_x = -100000;
		  me->p_y = -100000;
#ifdef SHORT_PACKETS
		  spwarning ("You can only warp to your own team's planets!", 101);
#else
		  warning ("You can only warp to your own team's planets!");
#endif
		}
	      else
		{
		  me->p_x = pln->pl_x;
		  me->p_y = pln->pl_y;
		  me->p_flags &= ~(PFPLLOCK);
		}
	    }
	}
      else
	{			/* this means we're just sitting somewhere presumably on a planet */
	  if (me->p_planet >= 0 && me->p_planet < MAXPLANETS)
	    {
	      pln = &planets[me->p_planet];
	      if (pln->pl_owner != me->p_team)
		{
		  me->p_planet = -1;
		  me->p_flags &= ~(PFPLLOCK);
		  me->p_x = -100000;
		  me->p_y = -100000;
#ifdef SHORT_PACKETS
		  spwarning ("Planet lock lost on change of ownership.", 102);
#else
		  warning ("Planet lock lost on change of ownership.");
#endif
		}
	    }
	}


      /* rest of the stuff here isn't really for observers */
      return;
    }

  if (me->p_flags & PFSELFDEST)
    {
      if (status->gamepaused && selfdest)
	selfdest = -2;		/* quitting during pause */
      if ((me->p_updates >= selfdest) ||
	  ((me->p_flags & PFGREEN) && (me->p_damage == 0)
	   && (me->p_shield == me->p_ship.s_maxshield)))
	{
	  me->p_flags &= ~PFSELFDEST;
	  me->p_explode = 10;
	  me->p_whydead = KQUIT;
	  me->p_status = PEXPLODE;
	}
      else
	{
	  switch ((selfdest - me->p_updates) / 10)
	    {
	    case 5:
	    case 4:
#ifdef SHORT_PACKETS
	      spwarning ("You notice everyone on the bridge is staring at you.", 83);
#else
	      warning ("You notice everyone on the bridge is staring at you.");
#endif
	      break;
	    default:		/* did this get eaten? -tsh */
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (ONEARG_TEXT, 1, (uchar) ((selfdest - me->p_updates) / 10));
		}
	      else
		{
#endif
		  sprintf (buf, "Stand By ... Self Destruct in %d seconds",
			   (selfdest - me->p_updates) / 10);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	      break;
	    }
	}
    }

  /* provide a refit countdown 4/6/92 TC */

  if (me->p_flags & PFREFITTING)
    {
      static int lastRefitValue = 0;	/* for smooth display */
      if (lastRefitValue != (rdelay - me->p_updates) / 10)
	{
	  lastRefitValue = (rdelay - me->p_updates) / 10;	/* CSE to the rescue? */
	  switch (lastRefitValue)
	    {
	    case 3:
	    case 2:
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (ONEARG_TEXT, 0, (uchar) lastRefitValue);
		}
	      else
		{
#endif
		  sprintf (buf, "Engineering:  Energizing transporters in %d seconds", lastRefitValue);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	      break;
	    case 1:
#ifdef SHORT_PACKETS
	      spwarning ("Engineering:  Energize. [ SFX: chimes ]", 63);
#else
	      warning ("Engineering:  Energize. [ SFX: chimes ]");
#endif
	      break;
	    case 0:
	      switch (rrandom () % 5)
		{
		case 0:
#ifdef SHORT_PACKETS
		  spwarning ("Wait, you forgot your toothbrush!", 64);
#else
		  warning ("Wait, you forgot your toothbrush!");
#endif
		  break;
		case 1:
#ifdef SHORT_PACKETS
		  spwarning ("Nothing like turning in a used ship for a new one.", 65);
#else
		  warning ("Nothing like turning in a used ship for a new one.");
#endif
		  break;
		case 2:
#ifdef SHORT_PACKETS
		  spwarning ("First officer:  Oh no, not you again... we're doomed!", 66);
#else
		  warning ("First officer:  Oh no, not you again... we're doomed!");
#endif
		case 3:
#ifdef SHORT_PACKETS
		  spwarning ("First officer:  Uh, I'd better run diagnostics on the escape pods.", 67);
#else
		  warning ("First officer:  Uh, I'd better run diagnostics on the escape pods.");
#endif
		  break;
		case 4:
#ifdef SHORT_PACKETS
		  spwarning ("Shipyard controller:  This time, *please* be more careful, okay?", 68);
#else
		  warning ("Shipyard controller:  This time, *please* be more careful, okay?");
#endif
		  break;
		}
	      break;
	    }
	}
    }

  /* provide a war declaration countdown 4/6/92 TC */

  if (me->p_flags & PFWAR)
    {
      static int lastWarValue = 0;
      if (lastWarValue != (delay - me->p_updates) / 10)
	{
	  lastWarValue = (delay - me->p_updates) / 10;	/* CSE to the rescue? */
	  switch (lastWarValue)
	    {
	    case 9:
#ifdef SHORT_PACKETS
	      spwarning ("Weapons officer:  Not again!  This is absurd...", 69);
#else
	      warning ("Weapons officer:  Not again!  This is absurd...");
#endif
	      break;
	    case 8:
	      break;
	    case 7:
#ifdef SHORT_PACKETS
	      spwarning ("Weapons officer:  ... the whole ship's computer is down?", 70);
#else
	      warning ("Weapons officer:  ... the whole ship's computer is down?");
#endif
	      break;
	    case 6:
	      break;
	    case 5:
#ifdef SHORT_PACKETS
	      spwarning ("Weapons officer:  Just to twiddle a few bits of the ship's memory?", 71);
#else
	      warning ("Weapons officer:  Just to twiddle a few bits of the ship's memory?");
#endif
	      break;
	    case 4:
	    case 3:
#ifdef SHORT_PACKETS
	      spwarning ("Weapons officer:  Bah! [ bangs fist on inoperative console ]", 72);
#else
	      warning ("Weapons officer:  Bah! [ bangs fist on inoperative console ]");
#endif
	      break;
	    case 2:
	    case 1:
	      break;
	    case 0:
#ifdef SHORT_PACKETS
	      spwarning (" Weapons officer: Finally! systems are back online!", 103);
#else
	      warning (" Weapons officer: Finally! systems are back online!");
#endif
	      break;
	    }
	}
    }

  /* give certain information about bombing or beaming */
  if (me->p_flags & PFBOMB)
    {
      if (planets[me->p_planet].pl_armies < 5)
	{
#ifdef SHORT_PACKETS
	  if (send_short)
	    {
	      swarn (BOMB_INEFFECTIVE, planets[me->p_planet].pl_armies, 0);
	    }
	  else
	    {
#endif
	      sprintf (buf, "Weapons Officer: Bombing is ineffective. Sensor read %d armies left.",
		       planets[me->p_planet].pl_armies);
	      warning (buf);
#ifdef SHORT_PACKETS
	    }
#endif
	  me->p_flags &= ~PFBOMB;
	}
      else
	{
#ifdef SHORT_PACKETS
	  if (send_short)
	    {
	      swarn (BOMB_TEXT, (uchar) me->p_planet, (uchar) planets[me->p_planet].pl_armies);
	    }
	  else
	    {
#endif
	      sprintf (buf, "Weapons Officer: Bombarding %s...  Sensors read %d armies left.",
		       planets[me->p_planet].pl_name,
		       planets[me->p_planet].pl_armies);
	      warning (buf);
#ifdef SHORT_PACKETS
	    }
#endif
	}
    }

  if (me->p_ship.s_type == ASSAULT)
    troop_capacity = (((me->p_kills * 3) > myship->s_maxarmies) ?
		      myship->s_maxarmies : (int) (me->p_kills * 3));
  else if (me->p_ship.s_type != STARBASE)
    troop_capacity = (((me->p_kills * 2) > myship->s_maxarmies) ?
		      myship->s_maxarmies : (int) (me->p_kills * 2));
  else
    troop_capacity = me->p_ship.s_maxarmies;

  if (me->p_flags & PFBEAMUP)
    {
      if (me->p_flags & PFORBIT)
	{
	  if (planets[me->p_planet].pl_armies < 5)
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (BEAMUP_TEXT, (uchar) me->p_planet, 0);
		}
	      else
		{
#endif
		  sprintf (buf, "%s: Too few armies to beam up",
			   planets[me->p_planet].pl_name);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	      me->p_flags &= ~PFBEAMUP;
	    }
	  else if (me->p_armies == troop_capacity)
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		swarn (TEXTE, 82, 0);
	      else
		{
#endif
		  sprintf (buf, "No more room on board for armies");
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	      me->p_flags &= ~PFBEAMUP;
	    }
	  else
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (BEAMUP2_TEXT, (uchar) me->p_armies, (uchar) troop_capacity);
		}
	      else
		{
#endif
		  sprintf (buf, "Beaming up.  (%d/%d)", me->p_armies, troop_capacity);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	    }
	}
      else if (me->p_flags & PFDOCK)
	{
	  if (players[me->p_docked].p_armies == 0)
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (BEAMUPSTARBASE_TEXT, (uchar) me->p_docked, 0);
		}
	      else
		{
#endif
		  sprintf (buf, "Starbase %s: Too few armies to beam up",
			   players[me->p_docked].p_name);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	      me->p_flags &= ~PFBEAMUP;
	    }
	  else if (me->p_armies == troop_capacity)
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (TEXTE, 82, 0);
		}
	      else
		{
#endif
		  sprintf (buf, "No more room on board for armies");
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	      me->p_flags &= ~PFBEAMUP;
	    }
	  else
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (BEAMUP2_TEXT, (uchar) me->p_armies, (uchar) troop_capacity);
		}
	      else
		{
#endif
		  sprintf (buf, "Beaming up.  (%d/%d)", me->p_armies, troop_capacity);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	    }
	}
    }

  if (me->p_flags & PFBEAMDOWN)
    {
      if (me->p_armies == 0)
	{
	  if (me->p_flags & PFDOCK)
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (BEAMDOWNSTARBASE_TEXT, (uchar) me->p_docked, 0);
		}
	      else
		{
#endif
		  sprintf (buf, "No more armies to beam down to Starbase %s.",
			   players[me->p_docked].p_name);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	    }
	  else
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (BEAMDOWNPLANET_TEXT, (uchar) me->p_planet, 0);
		}
	      else
		{
#endif
		  sprintf (buf, "No more armies to beam down to %s.",
			   planets[me->p_planet].pl_name);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
#ifdef STDBG
	      sprintf (buf, "%c%c-> No more armies to beam down to %s.",
		       teamlet[me->p_team], shipnos[me->p_no],
		       planets[me->p_planet].pl_name);
	      pmessage (buf, me->p_no, MINDIV | MDBG, "");
#endif
	    }
	  me->p_flags &= ~PFBEAMDOWN;
	}
      else if (me->p_flags & PFORBIT)
	{
#ifdef SHORT_PACKETS
	  if (send_short)
	    {
	      swarn (ARGUMENTS, (uchar) me->p_armies, (uchar) troop_capacity);	/* This fills the Argument Buffer */
	      swarn (BEAM_D_PLANET_TEXT, (uchar) me->p_planet, (uchar) planets[me->p_planet].pl_armies);
	      /* I use this because someone can change the army capacity and i want starbases with
	         with max 255 Armies */
	    }
	  else
	    {
#endif
	      sprintf (buf, "Beaming down.  (%d/%d) %s has %d armies left",
		       me->p_armies,
		       troop_capacity,
		       planets[me->p_planet].pl_name,
		       planets[me->p_planet].pl_armies);
	      warning (buf);
#ifdef SHORT_PACKETS
	    }
#endif
	}
      else if (me->p_flags & PFDOCK)
	{
	  if (players[me->p_docked].p_armies ==
	      players[me->p_docked].p_ship.s_maxarmies)
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (SBREPORT, (uchar) me->p_docked, 0);
		}
	      else
		{
#endif
		  sprintf (buf, "Transporter Room:  Starbase %s reports all troop bunkers are full!",
			   players[me->p_docked].p_name);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	      me->p_flags &= ~PFBEAMDOWN;
	    }
	  else
	    {
#ifdef SHORT_PACKETS
	      if (send_short)
		{
		  swarn (ARGUMENTS, (uchar) me->p_armies, (uchar) troop_capacity);	/* This fills the Argument Buffer */
		  swarn (BEAM_U_TEXT, (uchar) me->p_docked, (uchar) players[me->p_docked].p_armies);
		}
	      else
		{
#endif
		  sprintf (buf, "Transfering ground units.  (%d/%d) Starbase %s has %d armies left",
			   me->p_armies,
			   troop_capacity,
			   players[me->p_docked].p_name,
			   players[me->p_docked].p_armies);
		  warning (buf);
#ifdef SHORT_PACKETS
		}
#endif
	    }
	}
    }
  if (me->p_flags & PFREPAIR)
    {
      if ((me->p_damage == 0) && (me->p_shield == me->p_ship.s_maxshield))
	me->p_flags &= ~PFREPAIR;
    }
  if (me->p_flags & PFPLOCK)
    {				/* set course to player x */
      int dist;

      pl = &players[me->p_playerl];
      if (pl->p_status != PALIVE)
	me->p_flags &= ~PFPLOCK;
      if (pl->p_ship.s_type == STARBASE)
	{
	  dist = hypot ((double) (me->p_x - pl->p_x),
			(double) (me->p_y - pl->p_y));
	  if (dist - (DOCKDIST / 2) < (11500 * me->p_speed * me->p_speed) /
	      me->p_ship.s_decint)
	    {
	      if (me->p_desspeed > 2)
		{
		  set_speed (me->p_desspeed - 1);
		}
	    }
	  if ((dist < DOCKDIST) && (me->p_speed <= 2))
	    {
	      me->p_flags &= ~PFPLOCK;
	      orbit ();
	    }
	}
      if (me->p_flags & PFPLOCK)
	{
	  course = newcourse (pl->p_x, pl->p_y);
	  set_course (course);
	}
    }
  if (me->p_flags & PFPLLOCK)
    {				/* set course to planet x */
      int dist;

      pln = &planets[me->p_planet];
      dist = hypot ((double) (me->p_x - pln->pl_x),
		    (double) (me->p_y - pln->pl_y));

      /* This is magic.  It should be based on defines, but it slows
         the ship down to warp two an appropriate distance from the
         planet for orbit */

      if (dist - (ORBDIST / 2) < (11500 * me->p_speed * me->p_speed) /
	  me->p_ship.s_decint)
	{
	  if (me->p_desspeed > 2)
	    {
	      set_speed (2);
	    }
	}

      if ((dist < ENTORBDIST) && (me->p_speed <= 2))
	{
	  me->p_flags &= ~PFPLLOCK;
	  orbit ();
	}
      else
	{
	  course = newcourse (pln->pl_x, pln->pl_y);
	  set_course (course);
	}
    }
}

newcourse (x, y)
     int x, y;
{
  return ((unsigned char) (atan2 ((double) (x - me->p_x),
				  (double) (me->p_y - y)) / 3.14159 * 128.));
}
