/* $Log: defs.h,v $
 * Revision 1.4  1993/04/18  20:25:58  jmn
 * 3.99pl2
 *
 * Revision 1.3  1993/04/11  21:43:35  jmn
 * my changes in prep for rcs merge with snidstats
 *
 * Revision 1.1  1993/04/08  21:06:24  jmn
 * Initial revision
 *
 * Revision 1.4  92/04/01  15:36:00  terence
 * UDP v0.3 mods added
 * 
 * Revision 1.3  92/03/19  21:34:47  terence
 * Added UDP mods (version 0.2, 3/17/92)
 * 
 * Revision 1.2  92/03/11  15:49:41  terence
 * added UDP mods
 *  */

/* defs.h
 */
#include "copyright.h"

#ifndef _h_defs
#define _h_defs

#define NODET (char)(-1)

#define MAXQUEUE 30
#define INL_TEAMAX 8

#define FEATURE_FILE   "./.feature"	/* LAB 6/12/93 */

#ifdef RSA
#define RSA_KEY_FILE   "./RSAreserved"
#define RSA_VERSION     "RSA v2.0 INL SERVER"	/* String must begin with "RSA v" */
#define KEY_SIZE      32
#define RESERVED_SIZE 16
#define NAME_LEN      16
#define KEYMAP_LEN    96
#endif /* RSA */

#define MSG_LEN       80

#define MAXPLAYER 20
#define TESTERS 4		/* Priveledged slots for robots and game 'testers' */
#define MAXPLANETS 40
#define MAXTORP 8
#define MAXPLASMA 1
#define PKEY 128
#define WINSIDE 500		/* Size of strategic and tactical windows */
#define BORDER 4		/* border width for option windows */
#define PSEUDOSIZE 16
#define CLOAK_PHASES 7		/* number of drawing phases in a cloak engage/disengage */
#define NUMRANKS 9

/* random stuff that used to be in the middle of daemonII.c ugh  - jmn */
/* These specify how often special actions will take place in
   UPDATE units (0.10 seconds, currently.)
 */

#define PLAYERFUSE      1
#define TORPFUSE        1
#define PLASMAFUSE      1
#define PHASERFUSE      1
#define CLOAKFUSE       2
#define TEAMFUSE        5
#define PLFIGHTFUSE     5
#define BEAMFUSE        8	/* scott 8/25/90 -- was 10 */
#define PMOVEFUSE       10	/* planet movement fuse 10/10/91 TC */
/* #define PLANETFUSE   400     /* scott 8/25/90 -- was 600 */
#define PLANETFUSE      400/MAXPLANETS
/* for spreading out the planet popping INL4.0 ERic */
#define SURRENDFUSE     600	/* 1 minute 7/31/91 TC */
#define SYNCFUSE        3000
#define CHECKLOADFUSE   9000	/* change 1/26/91 -- was 600 */
#define HOSEFUSE        9000	/* back to 15 minutes 7/16/91 TC */
#define HOSEFUSE2       1800	/* 3 minutes 8/15/91 TC */

#define TWENTY          12000	/* 20 minute fuse RJ INL */
#define TEN             6000	/* 10 minute fuse RJ INL */
#define FIVE            3000	/* 5 minute fuse RJ INL */
#define ONE             600	/* 1 minute fuse RJ INL */

#define GHOSTTIME       (300)	/* 30 secs */
#define OUTFITTIME      (6 * AUTOQUIT * 1000000 / UPDATE)	/* 6 * AQ secs */

#define HUNTERKILLER    (-1)
#define TERMINATOR      (-2)	/* Terminator */
#define STERMINATOR     (-3)	/* sticky Terminator */

#define TIMEOUTLEN	FIVE


/* These are configuration definitions */

#define GWIDTH 100000		/* galaxy is 100000 spaces on a side */
#define WARP1 20		/* warp one will move 20 spaces per update */
#define SCALE 40		/* Window will be one pixel for 20 spaces */
#define EXPDIST 350		/* At this range a torp will explode */
#define DAMDIST 2000		/* At this range a torp does damage */
#define SHIPDAMDIST 3000	/* At this range, an exploding ship does damage */
#define PLASDAMDIST 2500	/* At this range, a plasma does damage */
#define DETDIST 1800		/* At this range a torp can be detonated */
#define PHASEDIST 6000		/* At this range a player can do damage with phasers */
#define ENTORBDIST 900		/* At this range a player can orbit a planet */
#define ORBDIST 800		/* A player will orbit at this radius */
#define ORBSPEED 2		/* This is the fastest a person can go into orbit */
#define PFIREDIST 1500		/* At this range a planet will shoot at a player */
#define UPDATE 100000		/* Update time is 100000 micro-seconds */
#define AUTOQUIT 60		/* auto logout in 60 secs */
#define VACANT -1		/* indicates vacant port on a starbase */
#define DOCKDIST 600
#define DOCKSPEED 2		/* If base is moving, there will be some
				   finesse involved to dock */
#define NUMPORTS 4
#define SBFUELMIN 10000		/* If starbase's fuel is less than this, it will not
				   refuel docked vessels */
#define TRACTDIST   6000	/* maximum effective tractor beam range */
#define TRACTEHEAT  5		/* ammount tractor beams heat engines */
#define TRACTCOST   20		/* fuel cost of activated tractor beam */
#define PLARMY      17		/* default initial number of armies */

/* These are memory sections */
#define PLAYER 1
#define MAXMESSAGE 50
#define MAXREVIEWMESSAGE 20

#define rosette(x)   ((((x) + 8) / 16) & 15)
/* #define rosette(x)   ((((x) + 256/VIEWS/2) / (256/VIEWS) + VIEWS) % VIEWS) */
/*                      (((x + 8) / 16 + 16)  %  16)  */

/* These are the teams */
/* Note that I used bit types for these mostly for messages and
   war status.  This was probably a mistake.  It meant that Ed
   had to add the 'remap' area to map these (which are used throughout
   the code as the proper team variable) into a nice four team deep
   array for his color stuff.  Oh well.
 */
#define NOBODY 0x0
#define FED 0x1
#define ROM 0x2
#define KLI 0x4
#define ORI 0x8
#define ALLTEAM (FED|ROM|KLI|ORI)
#define MAXTEAM (ALLTEAM)
#define NUMTEAM 4
/*
   ** These are random configuration variables
 */
#define VICTORY 3		/* Number of systems needed to conquer the galaxy */
#define WARNTIME 30		/* Number of updates to have a warning on the screen */
#define MESSTIME 30		/* Number of updates to have a message on the screen */

#define TARG_PLAYER	0x1	/* Flags for gettarget */
#define TARG_PLANET	0x2
#define TARG_CLOAK	0x4	/* Include cloaked ships in search */
#define TARG_SELF	0x8

/* Data files to make the game play across daemon restarts. */

#define NETREKDIR	"."

#define END_SCRIPT      "end_tourney"
#define REG_SCRIPT	"register_tourney"	/* register script */
#define GLOBAL		".global"
#define SCORES		".scores"
#define PLFILE		".planets"
#define MOTD		".motd"
#define RESERVATIONS	".reservations"
#define DAEMON		"daemonII"
#define LOGFILENAME     "logfile"
#define PLAYERFILE	".players"
#define CONQFILE	".conquer"
#define SYSDEF_FILE     ".sysdef"
#define INL_LOGFILE     "inl_log"	/* ALL messages */
#define INL_STATFILE    "inl_stats"
#define INL_TIMESTATS   ".inl_timestats"
#define TIME_FILE	".time" 	/* when is server up? */

/* jmn */
#define MAXRES 80		/* maximum number of reservations allowed */

/* Other stuff that Ed added */

#define ABS(a)			/* abs(a) */ (((a) < 0) ? -(a) : (a))
#ifndef MAX
#define MAX(a,b)		((a) > (b) ? (a) : (b))
#endif

#define myPlasmaTorp(t)		(me->p_no == (t)->pt_owner)
#define myTorp(t)		(me->p_no == (t)->t_owner)
#define friendlyPlasmaTorp(t)	((!(me->p_team & (t)->pt_war)) || (myPlasmaTorp(t)))
#define friendlyTorp(t)		(((!(me->p_team & (t)->t_war)) && \
				    (!(t->t_team & (me->p_swar | me->p_hostile)))) || \
				    (myTorp(t)))
#define myPhaser(p)		(&phasers[me->p_no] == (p))
#define friendlyPhaser(p)	(me->p_team == players[(p) - phasers].p_team)
#define myPlayer(p)		(me == (p))
#define myPlanet(p)		(me->p_team == (p)->pl_owner)
#define friendlyPlayer(p)	((!(me->p_team & \
				    ((p)->p_swar | (p)->p_hostile))) && \
				    (!((p)->p_team & \
				    (me->p_swar | me->p_hostile))))
#define isAlive(p)		((p)->p_status == PALIVE)
#define friendlyPlanet(p)	((p)->pl_info & me->p_team && \
			     !((p)->pl_owner & (me->p_swar | me->p_hostile)))

#define torpColor(t)		\
	(myTorp(t) ? myColor : shipCol[remap[players[(t)->t_owner].p_team]])
#define plasmatorpColor(t)		\
	(myPlasmaTorp(t) ? myColor : shipCol[remap[players[(t)->pt_owner].p_team]])
#define phaserColor(p)		\
	(myPhaser(p) ? myColor : shipCol[remap[players[(p) - phasers].p_team]])
/* 
 * Cloaking phase (and not the cloaking flag) is the factor in determining 
 * the color of the ship.  Color 0 is white (same as 'myColor' used to be).
 */
#define playerColor(p)		\
	(myPlayer(p) ? 		\
	    (cloak_pixels[0][me->p_cloakphase])	\
	    : (cloak_pixels[remap[(p)->p_team]][(p)->p_cloakphase]))
#define planetColor(p)		\
	(((p)->pl_info & me->p_team) ? shipCol[remap[(p)->pl_owner]] : unColor)

#define planetFont(p)		\
	(myPlanet(p) ? bfont : friendlyPlanet(p) ? ifont : dfont)
#define shipFont(p)		\
	(myPlayer(p) ? bfont : friendlyPlayer(p) ? ifont : dfont)
/* kludge to make new ratings go at about same rate as old ones */
#define bombingRating(p)	\
	((float) ((p)->p_stats.st_tarmsbomb+(p)->p_stats.st_tarmsogged*5 \
		+ (p)->p_stats.st_tarmsdel) * status->timeprod / \
	 ((float) (p)->p_stats.st_tticks * (status->armsbomb+status->armsdel) ))
#define planetRating(p)		\
	((float) (p)->p_stats.st_tplanets * status->timeprod / \
	 ((float) (p)->p_stats.st_tticks * status->planets))
#define offenseRating(p)	\
	((float) (p)->p_stats.st_tkills * status->timeprod / \
	 ((float) (p)->p_stats.st_tticks * status->kills))
#define defenseRating(p)	\
	((float) (p)->p_stats.st_tticks * status->losses / \
	 ((p)->p_stats.st_tlosses!=0 ? \
	  ((float) (p)->p_stats.st_tlosses * status->timeprod) : \
	  (status->timeprod)))

/* This macro allows us to time things based upon the SIGALRM signal.
 * Given a number of 1/5 seconds, it will return the number of SIGALRMs we
 *  will receive in that period.
 */
#define efticks(x) ((x)*200000/timerDelay)

/*
 * UDP control stuff
 */
#ifdef GATEWAY
#define UDP_NUMOPTS	11
#define UDP_GW		UDP_NUMOPTS-1
#else
#define UDP_NUMOPTS	10
#endif
#define UDP_CURRENT	0
#define UDP_STATUS	1
#define UDP_DROPPED	2
#define UDP_SEQUENCE	3
#define UDP_SEND	4
#define UDP_RECV	5
/* #define UDP_DEBUG    6 */
#define UDP_FORCE_RESET	7
#define UDP_UPDATE_ALL	8
#define UDP_DONE	9
#define COMM_TCP	0
#define COMM_UDP	1
#define COMM_VERIFY	2
#define COMM_UPDATE	3
#define COMM_MODE	4	/* put this one last */
#define SWITCH_TCP_OK	0
#define SWITCH_UDP_OK	1
#define SWITCH_DENIED	2
#define SWITCH_VERIFY	3
#define CONNMODE_PORT	0
#define CONNMODE_PACKET	1
#define STAT_CONNECTED	0
#define STAT_SWITCH_UDP	1
#define STAT_SWITCH_TCP	2
#define STAT_VERIFY_UDP	3
#define MODE_TCP	0
#define MODE_SIMPLE	1
#define MODE_FAT	2
#define MODE_DOUBLE	3	/* put this one last */

#define UDP_RECENT_INTR	300
#define UDP_UPDATE_WAIT 5	/* 5 second wait */

/* server version of UDPDIAG */
/* (change these to "#define UDPDIAG(x) <return>" for smaller & faster code) */
#ifdef UDP_DEBUG
#define UDPDIAG(x)	{ if (udpAllowed > 1) { printf("UDP: "); printf x; }}
#define V_UDPDIAG(x)	{ if (udpAllowed > 2) { printf("UDP: "); printf x; }}
#else
#define UDPDIAG(x)
#define V_UDPDIAG(x)
#endif

/* initial sysV compatibility stuff */
#if SYSV || _AIX
#define SIGNAL(x,y)   sigset(x,y)
#define PAUSE(x)      sigpause(x)
#else
#define SIGNAL(x,y)   signal(x,y)
#define PAUSE(x)      pause()
#endif

#ifdef SHORT_PACKETS
#if WINSIDE > 500
#undef SHORT_PACKETS
#endif
#define TEXTE 0
#define PHASER_HIT_TEXT 1
#define BOMB_INEFFECTIVE 2
#define BOMB_TEXT 3
#define BEAMUP_TEXT 4
#define BEAMUP2_TEXT 5
#define BEAMUPSTARBASE_TEXT 6
#define BEAMDOWNSTARBASE_TEXT 7
#define BEAMDOWNPLANET_TEXT 8
#define SBREPORT 9
#define ONEARG_TEXT 10
#define BEAM_D_PLANET_TEXT 11
#define ARGUMENTS 12
#define BEAM_U_TEXT 13
#define LOCKPLANET_TEXT 14
#define LOCKPLAYER_TEXT 15
#define SBRANK_TEXT 16
#define SBDOCKREFUSE_TEXT 17
#define SBDOCKDENIED_TEXT 18
#define SBLOCKSTRANGER 19
#define SBLOCKMYTEAM 20
/*      Daemon messages */
#define DMKILL 21
#define KILLARGS 22
#define DMKILLP 23
#define DMBOMB 24
#define DMDEST 25
#define DMTAKE 26
#define DGHOSTKILL 27
/*      INL     messages                */
#define INLDMKILLP 28
#define INLDMKILL 29		/* Because of shiptypes */
#define INLDRESUME 30
#define INLDTEXTE 31
/* Variable warning stuff */
#define STEXTE 32		/* static text that the server needs to send to the client first */
#define SHORT_WARNING 33	/* like CP_S_MESSAGE */
#define STEXTE_STRING 34
#define KILLARGS2 35

#ifdef SOLARIS2
#define bcopy(s,d,l) memmove((d), (s), (l))
#define bzero(b, l)  memset((b), 0, (l))
#define bcmp(a, b, l) memcmp((b), (a), (l))
#define index(s, c)  strchr((s), (c))
#define rindex(s, c) strrchr((s), (c))
#define random() rand()
extern double hypot();
#endif

/* Warning flags , used in socket.c */
#define SVALID    253		/* Mark server messages as valid to send over SP_S_MESSAGE */
#define SINVALID 254		/* Mark server Message as invalid to send over SP_S_MESSAGE */
#define DINVALID 255		/* Mark daemon ( GOD) Message as invalid to send over SP_S_WARNING */
#endif

/* we use this enough... just define it - jn */
#define RESETBASETIME	{ int i; for (i = 0; i <= MAXTEAM; i++) {teams[i].s_turns = 0;} }

/* THIS SHOULD BE LAST IN FILE!! */
#endif /* _h_defs */
