/* pop related stats structure 
$Id: newstats.h,v 1.1 1993/04/18 20:25:58 jmn Exp $
*/

#define NSTATS_TICKS_PER 3000   /* every ten minutes dump pop related stats */

/*

   IF YOU CHANGE THE DATA FILE FORMAT increment NSTATS_VERSION.  If the
   change is not backwards compatable, set NSTATS_COMPAT to the
   new NSTATS_VERSION (a few obscure cases are not handled, but
   it's not worth worrying about).

   Always try to add new fields to the end of the structure,
   and they should all be long or unsigned long.

*/

#define NSTATS_COMPAT	1	/* oldest compatible nstat file format */
#define NSTATS_VERSION	1	/* current nstat file format */
#define NSTATS_BYTESWAP_MAGIC	0x11223344

struct st_teamstats {
	struct xx_bomb {
		long	check,		/* Times enemy orbiting in bomb mode */
			check_core,	/* enemy bombing core planet */
			check_home,	/* enemy bombing home planet */
			num,		/* Total armies bombed by enemy */
			as,		/* Armies bomb with an AS by enemy */
			u4_num,		/* Total armies bombed < 4 by enemy */
			u4_as,		/* Armies bombed under 4 by AS enemy */
			core,		/* Armies on core planets bombed */
			home;		/* Armies on home planet bombed */
	}	bomb;
	struct xx_drop {
		long	num,		/* Total armies dropped by enemy */
			dummy,		/* drops that should be bombs */
			reinf,		/* Armies used by us for reinf (<4) */
			core,		/* Armies dropped by enemy in core */
			home;		/* Armies dropped by enemy on home */
	}	drop;
	struct xx_planet {
		long	destroyed,	/* Planets destroyed */
			taken;		/* Planets taken */
	}	planet;
	struct xx_plague {
		long	hit,		/* Number of times plague hit */
			count,		/* Number of armies plague killed */
			low;		/* Lowest remaining total on any one
						plagued planet */
	}	plague;
	struct xx_pop {
		long	check,		/* total our planets checked for pop */
			hit,		/* total actual pops */
			num;		/* total armies popped */
		struct {
			long	check,	/* check for low army count */
				hit;	/* 1 in 20, always +1 */
		}	low;
		struct {
			long	check,	/* 1 in 5 */
				hit;	/* always +1 army */
		}	agri;
		struct {
			long	check,	/* <4 agri always pops */
				lucky;	/* <4 agri popped to 4 by "low" code */
		}	low_agri;
	}	pop;

	long	carried,		/* armies killed aboard carriers */
		deaths,			/* players killed */
		start;			/* total armies this phase */

	struct xx_player {
		long	num,		/* +1 every tick for PALIVE */
			lowfuel,	/* +1 every tick fuel < 15% */
			damaged;	/* +1 every tick damage > 50% */
	}	player;
};

struct st_new_stats {
	struct st_new_stats *next;
	long	age,			/* tick number at creation time */
		period,			/* INL period (identifies OT) */
		time;			/* minute number since start */
	struct st_teamstats team[NUMTEAM + 1];	/* 0 for indi */
};
