/*
 * data.c
 */
#include "copyright.h"

#include <stdio.h>
#include "Wlib.h"
#include "defs.h"
#include "xsg_defs.h"
#include "struct.h"
#include "data.h"

struct player *players;
struct player *me=NULL;
struct torp *torps;
struct plasmatorp *plasmatorps;
struct status *status;
struct ship *myship;
struct stats *mystats;
struct planet *planets;
struct phaser *phasers;
struct message *messages;
struct mctl *mctl;
struct memory *sharedMemory;	/* for game recorder */
struct memory universe;		/* used to check for updates */

int 	record=0;
int 	playback=0;
char	*recfile = NULL;		/* game playback */
int	playMode = FORWARD|DO_STEP;	/* "" */
int     whichFrame = 0;
int     latestFrame = -1;
int     allocFrames = MAXFRAMES;
int	recordSpeed = 2;		/* default 2 updates/second */

int	oldalert = PFGREEN;	/* Avoid changing more than we have to */
int 	remap[16] = { 0, 1, 2, 0, 3, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0 };
int	messpend;
int	lastcount;
int	mdisplayed;
int	redrawall;
int	nopilot = 1;
int	selfdest;
int	udcounter;
int	lastm;
int	delay;			/* delay for decaring war */
int	rdelay;			/* delay for refitting */
int	mapmode = 2; 
int	namemode = 1; 
int	showStats;
int	showShields = 1;
int	msgBeep = 1;		/* ATM - msg beep */
int	warncount = 0;
int	warntimer = -1;
int	infomapped = 0;
int	scanmapped = 0;		/* ATM - scanners */
int	mustexit = 0;
int	messtime = 5;
int	keeppeace = 0;
int	showlocal = 0;		/* ATM: show owner */
int 	showgalactic = 1;	/* ATM: show resources */
char 	*shipnos="0123456789abcdefghijklmnopqrstuvwxyz";
int 	sock= -1;
int	xtrekPort=6592;		/* ATM: was 592 (inetd version) */
int	queuePos= -1;
int	pickOk= -1;
int	lastRank= -1;
int	promoted= 0;
int	loginAccept= -1;
unsigned localflags=0;
int	tournMask=15;
int 	nextSocket;	/* socket to use when we get ghostbusted... */
int	updatePlayer[MAXPLAYER];	/* Needs updating on player list */
int	updatePlanet[MAXPLANETS];	/* Needs updating on planet list */
char   *serverName="crp11.gs.com";
int	loggedIn=0;
int 	reinitPlanets=0;
int	redrawPlayer[MAXPLAYER];	/* Needs redrawing on galactic map */
int	lastUpdate[MAXPLAYER]={0};	/* Last update of this player */
int     timerDelay=200000;		/* micro secs between updates */
int	reportKills=1;			/* report kill messages? */
int	oldmctl=0;			/* old message posn */
int	plmode = 0;			/* planets/player stats */
int	chaos = 0;
int	show_xsg_posn = 1;		/* show xsg "cursor" */
int	updateSpeed = 2;		/* default 2 updates/second */
int	udpAllowed = 1;			/* UDP */
int	extracting = 0;			/* 7/27/93 BM */
int	currentFrame = 0;		/* 7/30/93 BM */

W_Icon stipple, clockpic, icon;

W_Color	borderColor, backColor, textColor, myColor, warningColor, shipCol[5],
	rColor, yColor, gColor, unColor, foreColor;

W_Icon expview[EX_FRAMES];
W_Icon sbexpview[SBEXPVIEWS];
W_Icon cloud[NUMDETFRAMES];
W_Icon plasmacloud[NUMDETFRAMES];
W_Icon etorp, mtorp;
W_Icon eplasmatorp, mplasmatorp;
W_Icon shield, cloakicon, xsgbits;
W_Icon fed_bitmaps[NUM_TYPES][VIEWS],
       kli_bitmaps[NUM_TYPES][VIEWS],
       rom_bitmaps[NUM_TYPES][VIEWS],
       ori_bitmaps[NUM_TYPES][VIEWS],
       ind_bitmaps[NUM_TYPES][VIEWS] ;
W_Icon bplanets[6];
W_Icon mbplanets[6];
W_Icon bplanets2[8];
W_Icon mbplanets2[8];

char teamlet[] = {'I', 'F', 'R', 'X', 'K', 'X', 'X', 'X', 'O'};
char *teamshort[9] = {"IND", "FED", "ROM", "X", "KLI", "X", "X", "X", "ORI"};
char pseudo[PSEUDOSIZE];
char login[PSEUDOSIZE];

char           *shiptypes[NUM_TYPES + 1] = {"SC", "DD", "CA", "BB", "AS", "SB",
#if NUM_TYPES == 7
"AT", "??",
#else
"GA", "AT", "??",
#endif
};

struct rank ranks[NUMRANKS] = {
    { 0.0, 0.0, 0.0, "Ensign"},
    { 2.0, 1.0, 0.0, "Lieutenant"},
    { 4.0, 2.0, 0.8, "Lt. Cmdr."}, 
    { 8.0, 3.0, 0.8, "Commander"},
    {15.0, 4.0, 0.8, "Captain"},
    {20.0, 5.0, 0.8, "Flt. Capt."},
    {25.0, 6.0, 0.8, "Commodore"},
    {30.0, 7.0, 0.8, "Rear Adm."},
    {40.0, 8.0, 0.8, "Admiral"}};

W_Window messagew, w, mapw, statwin, baseWin, infow, iconWin, war, robotwin=0,
	warnw, helpWin, plstatw, optionWin = 0, reviewWin, modifyWin = 0;
int tournplayers=5;
int shipsallowed[NUM_TYPES];
int weaponsallowed[WP_MAX];
int plkills=2;
int sbrank=3;
int startplanets[MAXPLANETS];
int binconfirm=1;
int hourratio=1;
int hiddenenemy=1;
float maxload=0.7;
int cyborg=0;         /* ATM */
int testtime;
int mapfire=1;                /* TSH 2/10/93 */
int runclock=1;               /* TSH 2/93 */
char godsname[32];    /* TSH 2/93 */
int frameskip=20;     /* TSH 4/93 */

/* the index into distmacro array should correspond
   with the correct dist_type */

struct  dmacro_list distmacro[] = {
        { 'X', "no zero", "this should never get looked at" },
        { 'T', "taking", "%T%c@%b: (%S) Carrying %a to %l%?%n>-1%{ @ %n%}"},
        { 'o', "ogg", "%T%c: Help Ogg %p at %l" },
        { 'b', "bomb", "%T%c: %?%n>4%{bomb %l @ %n%!bomb%}"},
        { 'c', "space_control", "%T%c: Help Control at %L" },
        { '1', "save_planet", "%T%c: Help at %l! %?%a>0%{ (have %a arm%?%a=1%{y%!ies%}) %} %s%% shld, %d%% dam, %f%% fuel" },
        { '2', "base_ogg", "%T%c: Sync with --]> %g <[-- OGG ogg OGG base!!" },
        { '3', "help1", "%T%c: Help me! %d%% dam, %s%% shd, %f%% fuel %a armies. " },
        { '4', "help2", "%T%c: Help me! %d%% dam, %s%% shd, %f%% fuel %a armies. " },
        { 'e', "escorting", "%T%c: ESCORTING %g (%d%%D %s%%S %f%%F)" },
        { 'O', "ogging", "%T%c: Ogging %h" },
        { 'B', "bombing", "%T%c: Bombing %l @ %n" },
        { 'C', "controlling", "%T%c: Controlling at %l" },
        { '5', "asw", "%T%c: Anti-bombing %p near %b." } ,
        { '6', "asbomb", "%T%c: DON'T BOMB %l. Let me bomb it (%S)" } ,
        { '7', "doing1", "%T%c: (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal.  %d%% dam, %s%% shd, %f%% fuel" } ,
        { '8', "doing2", "%T%c: (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal.  %d%% dam, %s%% shd, %f%% fuel" } ,
        { 'f', "free_beer", "%T%c: %p is free beer" },
        { 'n', "no_gas", "%T%c: %p @ %l has no gas" },
        { 'h', "crippled", "%T%c: %p @ %l crippled" },
        { '9', "pickup", "%T%c: %p++ @ %l" },
        { '0', "pop", "%T%c: %l%?%n>-1%{ @ %n%}!"},
        { 'F', "carrying", "%T%c@%b: %?%S=SB%{Your Starbase is c%!C%}arrying %?%a>0%{%a%!NO%} arm%?%a=1%{%y%!ies%}.\0" },
        { '@', "other1", "%T%c: (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal. (%d%%D, %s%%S, %f%%F)" },
        { '#', "other2", "%T%c: (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal. (%d%%D, %s%%S, %f%%F)" },
        { 'E', "help", "%T%c@%b: Help(%S)! %?%s<10%{SHLDS OUT! %!%?%s<90%{%s%% shd %}%}%?%d>10%{%?%d<90%{%d%% dmg %!%d%% DMG! %}%}%?%f<10%{NO GAS! %!%?%f<90%{%f%% fuel %}%}%?%S=SB%{%w%% wtmp %!%}%E%{ETEMP!! %}%W%{WTEMP!! %}%?%a>0%{%a armies! %}" },
        { '\0', '\0', '\0'},
};

